"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _industry = require("industry");

var _industryInclude = require("industry-include");

var _industryInstance = require("industry-instance");

var _industryFunctions = require("industry-functions");

var _industryStandardIo = require("industry-standard-io");

var _industryState = require("industry-state");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.default = (0, _industry.factory)().set("init", function (Class) {
  return function (_Class) {
    _inherits(_class, _Class);

    function _class() {
      var _Object$getPrototypeO;

      _classCallCheck(this, _class);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var _this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(_class)).call.apply(_Object$getPrototypeO, [this].concat(args)));

      _this.standardIO();
      _this.include(__dirname, {
        files: {
          dirs: {},
          files: [__dirname + "/cookie.js"],
          values: [require("./cookie").default]
        }
      });
      _this.stateful();

      if (_get(Object.getPrototypeOf(_class.prototype), "init", _this)) {
        var _get2;

        (_get2 = _get(Object.getPrototypeOf(_class.prototype), "init", _this)).call.apply(_get2, [_this].concat(args));
      }
      return _this;
    }

    return _class;
  }(Class);
}).set("functions", _industryFunctions.functions).set("include", _industryInclude.include).set("instance", _industryInstance.instance).set("standard_io", _industryStandardIo.standard_io).set("state", _industryState.state);
//# sourceMappingURL=factory.js.map