"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _factory = require("./factory");

var _factory2 = _interopRequireDefault(_factory);

var _jsCookie = require("js-cookie");

var _jsCookie2 = _interopRequireDefault(_jsCookie);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Cookie = function () {
  function Cookie() {
    _classCallCheck(this, Cookie);
  }

  _createClass(Cookie, [{
    key: "init",
    value: function init(_ref) {
      var client = _ref.client;

      if (client) {
        this.state({ cache: _jsCookie2.default.getJSON("variate") || {} });
      }
    }
  }, {
    key: "get",
    value: function get(_ref2) {
      var key = _ref2.key;
      var _ref2$state = _ref2.state;
      var cache = _ref2$state.cache;
      var client = _ref2$state.client;

      if (client) {
        return { variant: cache[key] };
      } else {
        return {};
      }
    }
  }, {
    key: "key",
    value: function key(_ref3) {
      var name = _ref3.name;
      var converted = _ref3.converted;

      var key = [name];
      if (converted) {
        key.unshift("c");
      }
      return { key: key.join(":") };
    }
  }, {
    key: "read",
    value: function read(_ref4) {
      var chain = _ref4.promise.chain;

      return chain(this.key, this.get);
    }
  }, {
    key: "set",
    value: function set(_ref5) {
      var converted = _ref5.converted;
      var key = _ref5.key;
      var variant = _ref5.variant;
      var _ref5$state = _ref5.state;
      var cache = _ref5$state.cache;
      var client = _ref5$state.client;
      var cookie = _ref5$state.cookie;

      if (client) {
        cache[key] = converted || variant;
        _jsCookie2.default.set("variate", cache, cookie);
        this.state({ cache: cache });
        return { variant: cache[key] };
      } else {
        return {};
      }
    }
  }, {
    key: "write",
    value: function write(_ref6) {
      var chain = _ref6.promise.chain;

      return chain(this.key, this.set);
    }
  }]);

  return Cookie;
}();

exports.default = (0, _factory2.default)(Cookie);
//# sourceMappingURL=cookie.js.map